require("ArizonaAPI")
require("lts")
local ffi = require("ffi")
local state = false

ffi.cdef"int GetSystemMetrics(int);"

function main()
    sampRegisterChatCommand("displaytime", function() state = not state
    sampAddChatMessage((state and ': ' or ': '), 0xFFFFFFFF) renderEnd(nId) end)
    sampRegisterChatCommand('setsize', saveCfg)
    sampRegisterChatCommand('setcolor', saveCfgcolor)
    sampRegisterChatCommand('biasx', biasx)
    sampRegisterChatCommand('biasy', biasy)
    if not doesDirectoryExist('TrilogyLoader/config') or not doesFileExist('TrilogyLoader/config/timecfg.txt') then
        createDirectory('TrilogyLoader/config/')
        file = io.open('TrilogyLoader/config/timecfg.txt','w')
        file:write("size=20\ncolor=0xFF9999FF\nbiasx=0\nbiasy=0")
        file:close()
        readCfg()
        newTask(function()
            wait(5000)
            state = true
        end)
    else
        readCfg()
    end
end

function saveCfg(size)
    state = false
    file = io.open('TrilogyLoader/config/timecfg.txt','w')
    file:write("size="..size.."\ncolor="..color.."\nbiasx="..biasx.."\nbiasy="..biasy)
    file:close()
    readCfg()
    renderEnd(nId)
    newTask(function()
        wait(500)
        state = true
    end)
end

function saveCfgcolor(color)
    state = false
    file = io.open('TrilogyLoader/config/timecfg.txt','w')
    file:write("size="..size.."\ncolor="..color.."\nbiasx="..biasx.."\nbiasy="..biasy)
    file:close()
    readCfg()
    renderEnd(nId)
    newTask(function()
        wait(500)
        state = true
    end)
end

function biasx(biasx)
    state = false
    file = io.open('TrilogyLoader/config/timecfg.txt','w')
    file:write("size="..size.."\ncolor="..color.."\nbiasx="..biasx.."\nbiasy="..biasy)
    file:close()
    readCfg()
    renderEnd(nId)
    newTask(function()
        wait(500)
        state = true
    end)
end

function biasy(biasy)
    state = false
    file = io.open('TrilogyLoader/config/timecfg.txt','w')
    file:write("size="..size.."\ncolor="..color.."\nbiasx="..biasx.."\nbiasy="..biasy)
    file:close()
    readCfg()
    renderEnd(nId)
    newTask(function()
        wait(500)
        state = true
    end)
end

function readCfg()
    file = io.open('TrilogyLoader/config/timecfg.txt','r')
    local cfg = file:read("*a")
    size = cfg:match('size=(%d+)')
    color = cfg:match('color=(%w+)')
    biasx = cfg:match('biasx=(%S+)')
    print(biasx)
    biasy = cfg:match('biasy=(%S+)')
    print(biasy)
    local sX, sY = getScreenResolution()
    X = sX/4.5024501208
    Y = sY/1.031378378
    file:close()
    newTask(function()
        wait(500)
        state = true
    end)
end

function getScreenResolution()
    return ffi.C.GetSystemMetrics(0), ffi.C.GetSystemMetrics(1)
end


function onUpdate()
    if state then
        local nId = renderAddText(biasx + X, biasy + Y, color, size, os.date("%H:%M:%S"))
        newTask(function()
            wait(60)
            renderEnd(nId)
        end)
    end
end